{{ Maxim "MAX7219" LED driver
12/1/2013 - first run
}}


VAR     'MAX7219 pins
  Byte                Load
  Byte                Clk
  Byte                Dout

VAR
  Byte                Shut_flag
  Byte                Test_flag

PUB Init (Dout_Pin, Clk_Pin, Load_Pin, Digit_Count, Decode_Mode, Bright)
    
    Load := Load_Pin
    Dout := Dout_Pin
    Clk := Clk_Pin

    Shut_flag := 0
    Test_flag := 0

    LOW (Load)
    LOW (Dout)
    LOW (Clk)


    Decode (Decode_Mode)
    Brightness (Bright)
    Scan_Limit (Digit_Count)
    Shutdown
    
PUB Decode (Mode)'Read MAX7219 Datasheet for decode mode
    Load_7219 ($09, mode)

PUB Brightness (Value)'brightness level 1 to 16
    Load_7219 ($0A, value)

PUB Scan_Limit (no_Digits)'Number of Digits 1 to 8
    Load_7219 ($0B, no_Digits - 1)

PUB Shutdown
    !Shut_flag
    Load_7219 ($0C, Shut_flag)

PUB _Test
    !Test_flag
    Load_7219 ($0F, Test_flag)
       
PUB Load_7219 (Address, _Data)
  LOW (Load)
  
''  debug.hex(address, 2)
''  debug.putc(13)
  Address <<= (32 - 8)                       
  repeat 8
    outa[Dout] := (Address <-= 1) & 1                 
    Clock

''  debug.bin(_data, 8)
''  debug.putc(13)
  _Data <<= (32 - 8)
  repeat 8
    outa[Dout] := (_Data <-= 1) & 1
    Clock
    

  _Load
  LOW (Load)

PRI Clock
    waitcnt(cnt+((clkfreq / 100000 * 10) - 4296) #> 381)
    !outa[Clk]
    waitcnt(cnt+((clkfreq / 100000 * 10) - 4296) #> 381)
    !outa[Clk]

PRI _Load
    waitcnt(cnt+((clkfreq / 100000 * 10) - 4296) #> 381)
    !outa[Load]
    waitcnt(cnt+((clkfreq / 100000 * 10) - 4296) #> 381)
    !outa[Load]
         
PRI LOW(Pin)
    dira[Pin]~~
    outa[Pin]~
   